// -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-

///////////////////////////////////////////////////////////////////////////////
// 
//  driver/typeupd/src/main.c
//
///////////////////////////////////////////////////////////////////////////////

// ιԤ򥳥ȥȤȡǥХɥ饤ФȤ߹फɤ
// 󥽡ǻǤ롣
// #define ASK_BEFORE_STARTING

#include <basic.h>
#include <inner.h>
#include <bstdlib.h>
#include <errcode.h>
#include <driver/driver.h>
#include <driver/kbpd.h>
#include <driver/rs.h>
#include <driver/pcmcia.h>
#include <kernel/util.h>
#include <bsys/util.h>
#include <bsys/cons_io.h>
#include <bsys/cio_svc.h>
#include <util/debug.h>

#include <bstring.h>
#include <tstring.h>
#include <tctype.h>

#include <driver/usb.h>
//#include <driver/pcat/biosp.h>
//#include <driver/hwres.h>
#include <btron/device.h>

// ǥХåκݤϰʲ򥳥ȥȤȽϤ򸫤
//#define DEBUG_OUTPUT

//

#ifndef DEBUG_OUTPUT
#ifdef DEBUG_PRINT
#undef DEBUG_PRINT
#define DEBUG_PRINT(x) /* null */
#endif
#endif

#define	EC_MASK			(0xffff0000)
#define	ED_MASK			(0x0000ffff)
#define	toERR(class,detail)	((ERR)((class) << 16 | (UH)(detail)))

#define TOUCHPANEL_VENDOR_ID  0x056a
#define FAVO430_PRODUCT_ID 0x0013
#define FAVO440_PRODUCT_ID 0x0015
#define BIZTABLET_PRODUCT_ID 0x0063
#define DEVICE_NAME           "f430"

// USB HID Device
typedef struct {
  UB bLength;
  UB bDescriptorType;
  UH bcdHID;
  UB bCountryCode;
  UB bNumDescriptors;
  UB bDescriptorType2;
  UH wDescriptorLength;
} usbHIDDescriptor;

// Touch Panel Driver Information
typedef struct {
  ID      deviceID;
  ID      acceptingPort;
  DevReq *deviceRequest;
  Bool    opened;
  //
  ID      usbDeviceID;
  usbDeviceDescriptor        *deviceDesc;
  usbConfigurationDescriptor *configDesc;
  UB                         *reportDesc;
  W       reportDescSize;
  //
  ID      interfaceID;
  ID      interruptPipeID;
  ID      interruptPipeMailboxID;
  ID      interruptHandlerTaskID;
  UB     *interruptBuffer;
  W       reportSize;
  //
  ID      touchPanelMonitorTaskID;
  ID      kbpdMailboxID;
  //
  W       devWidth, devHeight;
} DriverInfo;

static W scrWidth, scrHeight;

static struct {
  W x, y;
} pressedLocation = {0, 0};

// 

static PRI taskPriority = 25; // the default priority is 25

//

static ERR  GetParameters(TC *arg);
static WERR StartDriver();
static WERR RegisterDevice(DriverInfo *driverInfo, Bool reg);
static ERR  RegisterDriverToKBPD(DriverInfo *driverInfo);
static ERR  StartAcceptingDeviceRequests(DriverInfo *driverInfo);
static ERR  ProcessDeviceRequest(DriverInfo *driverInfo,
                                 DevRsp *deviceResponse,
                                 DevReq *deviceRequest);
static ERR  ProcessOpenDeviceRequest(DriverInfo *driverInfo, ID deviceID);
static ERR  ProcessCloseDeviceRequest(DriverInfo *driverInfo);
static ERR ProcessReadRequest(DriverInfo *driverInfo,
                              DevRsp *deviceResponse,
                              DevReq *deviceRequest);
static ERR ProcessWriteRequest(DriverInfo *driverInfo,
                              DevRsp *deviceResponse,
                              DevReq *deviceRequest);
static ERR  ProcessUSBEventRequest(DriverInfo *driverInfo,
                                   DevRsp *deviceResponse,
                                   DevReq *deviceRequest);
static ERR  SetAndCheckTaskSpace(DevReq *deviceRequest);
static WERR CheckDataCount(DevReq *deviceRequest, W dataSize);
static ERR  OpenDevice(DriverInfo *driverInfo);
static void CloseDevice(DriverInfo *driverInfo);
//
static ERR GetDescriptors(DriverInfo *driverInfo);
#if 0
static ERR  GetDeviceDescriptor(DriverInfo *driverInfo);
static ERR  GetConfigurationDescriptor(DriverInfo *driverInfo);
#endif
static ERR	device_init(W did, W bnumif /*, W bepadr*/);
static ERR  GetReportDescriptor(DriverInfo *driverInfo);
//
static void PrintDeviceDescriptor(usbDeviceDescriptor *deviceDesc);
static void PrintConfigurationDescriptor(usbConfigurationDescriptor *configDesc);
static void PrintInterfaceDescriptor(usbInterfaceDescriptor *interfaceDesc);



ERR main(Bool startUp, TC *arg)
{
  ERR   errorCode;
  W     taskID;
  
#ifdef ASK_BEFORE_STARTING
  // ǥХϿ뤫ɤꤹ
  {
    char  inputString[256];
    printf("f430: do you want to start f430? (yes): ");
    gets(inputString);
    if (strcmp(inputString, "yes")) {
      printf("f430: quitting...\n");
      return ER_OK;
    }
  }
#endif
  
  // λ׵̵뤹
  if (!startUp) {
    DEBUG_PRINT(("f430: startUp is not true"));
    return ER_NOSPT;
  }
  
  DEBUG_PRINT(("f430: started\n"));
  
  // ѥ᡼Ф
  if (arg != NULL) {
    if ((errorCode = GetParameters(arg)) < ER_OK)
      return errorCode;
  }

  if ((errorCode = taskID = StartDriver()) < ER_OK) {
    DEBUG_PRINT(("failed to start the main task\n"));
    goto error;
  }

  return ER_OK;

 error:
  DEBUG_PRINT(("main() returned error code %d\n", errorCode));
  return errorCode;
}

WERR RegisterDevice(DriverInfo *driverInfo, Bool reg)
{
  static DevDef deviceDef = {
    {0},      // device attributes
    1,        // number of subunits
    {0x0000}, // device name
    0         // port ID
  };
  ERR	errorCode;
  
  // Ͽ
  eucstotcs(deviceDef.name, DEVICE_NAME);
  deviceDef.attr.chardev = 1;
  deviceDef.attr.devinfo = 0;
  deviceDef.attr.nowait  = 1;
  deviceDef.portid       = driverInfo->acceptingPort;
	
  // ǥХϿ
  if ((errorCode = b_DefDevice(&deviceDef, NULL)) < ER_OK)
    goto error;
  driverInfo->deviceID = (ID)errorCode;
  DEBUG_PRINT(("driverInfo->deviceID = %d\n", driverInfo->deviceID));
  driverInfo->opened = False;
  
  // kbpdɥ饤Ф˥ɥ饤ФϿ
  if ((errorCode = RegisterDriverToKBPD(driverInfo)) < ER_OK)
    goto error;

  return ER_OK;
  
 error:
  DEBUG_PRINT(("registerDevice() returned error code 0x%08x\n", errorCode));
  return errorCode;
}

static void MainTask(DriverInfo *driverInfo)
{
  ERR             errorCode;
  T_CPOR          cpor;
  usbEventPattern usbAnyDeviceEventPattern = {0, 0, 0, EVENT_ANY};
  
  // ǥХ׵դѥǥ֥ݡȤ
  cpor.poratr  = TA_NULL;        // ݡ°
  cpor.maxcmsz = sizeof(DevReq); // ƤӽФåκĹ
  cpor.maxrmsz = sizeof(DevRsp); // åκĹ
  if ((errorCode = vcre_por(&cpor)) < E_OK) {
    DEBUG_PRINT(("f430: failed to create a rendezvous port\n"));
    goto error;
  }
  driverInfo->acceptingPort  = (ID)errorCode;
  
  // USB٥ȤϿ
  if ((errorCode = usbRegistDevice(driverInfo->acceptingPort,
                                   &usbAnyDeviceEventPattern)) < E_OK) {
    DEBUG_PRINT(("usbRegistDevice() returned error code %d\n", errorCode));
    goto error;
  }
#if 0	// XXX
  // XXX 줬unsupported usb eventȯ
  if ((errorCode = usbRegistInterface(driverInfo->acceptingPort,
				      &usbAnyDeviceEventPattern)) < E_OK) {
    DEBUG_PRINT(("usbRegistInterface() returned error code %d\n", errorCode));
    goto error;
  }
#endif  // XXX
  // ǥХϿ
  if ((errorCode = RegisterDevice(driverInfo, True)))
    goto error;

  // ǥХ׵դ
  if ((errorCode = StartAcceptingDeviceRequests(driverInfo)) < ER_OK)
    goto error;

  // 餳ˤϤʤ
  
 error:
  Kfree((VB*)driverInfo);
  DEBUG_PRINT(("f430: MainTask() returned error code %d\n", errorCode));
  exd_tsk();
}

void TransformPoint(DriverInfo *driverInfo, W x, W y, W *xxxx, W *yyyy)
{
  *xxxx = x * PDIN_XMAX / driverInfo->devWidth;
  *yyyy = y * PDIN_YMAX / driverInfo->devHeight;
}

static void InterruptHandlerTask(DriverInfo *driverInfo)
{
  //  int i;
  W       errorCode = E_OK;
  usbMsg  message;
  W       messageLength;
  W       prevButtonState = 0;
  PdInput messageToKBPD = {
    // T_MSG head;
    {},
    // PDInStat stat;
    {
      0, INP_PD, 0, 0,
      0, 0, 0, 1, 0, 0, 0, 0,
      0, 0, 0, 0, 0, 0,
    },
    // H xpos;
    0,
    // H ypos;
    0,
  };
  W x, y;
	static W px,py; // ľΰ

  DEBUG_PRINT(("InterruptHandlerTask(): started\n"));

  while (True) {
    errorCode = rcv_mbf((VP)&message,
                        &messageLength,
                        driverInfo->interruptPipeMailboxID);
    if (errorCode == ER_NONE) {
      DEBUG_PRINT(("InterruptHandlerTask(): timeout\n"));
      continue;
    } else if (errorCode != ER_OK) {
      DEBUG_PRINT(("rcv_mbf() failed\n"));
      goto error;
    }
    if (message.error == USB_ERR_ABORT) {
      DEBUG_PRINT(("f430: USB_ERR_ABORT\n"));
      break;
    } else if (message.error == USB_ERR_STALL ||
               message.error == USB_ERR_IO_BABBLE) {  // XXX Ȥꤢ
      DEBUG_PRINT(("f430: USB_ERR_STALL (error=%#x, pid=%d)\n",
                   message.error, message.pid));  // XXX
      errorCode = usbStallPipe(message.pid, 0); // CLEAR_FEATURE
      if (errorCode < ER_OK)
        DEBUG_PRINT(("usbStallPipe() failed\n"));
      errorCode = usbIoPipe(driverInfo->interruptPipeID,
                            driverInfo->interruptBuffer,
                            driverInfo->reportSize,
                            NULL);
      if (errorCode < ER_OK)
        DEBUG_PRINT(("usbIoPipe() failed\n"));
    } else if (message.error == USB_OK
               && message.pid == driverInfo->interruptPipeID) {
      // kbpd˥å
      DEBUG_PRINT(("%02x %02x %02x %02x %02x %02x %02x %02x %d\n",
                   driverInfo->interruptBuffer[0],
                   driverInfo->interruptBuffer[1],
                   driverInfo->interruptBuffer[2],
                   driverInfo->interruptBuffer[3],
                   driverInfo->interruptBuffer[4],
                   driverInfo->interruptBuffer[5],
                   driverInfo->interruptBuffer[6],
                   driverInfo->interruptBuffer[7],
                   driverInfo->reportSize));

      if ((driverInfo->interruptBuffer[1] & 0x90) != 0) {	// XXX Ǥͭ
        TransformPoint(driverInfo,
                       driverInfo->interruptBuffer[2]
                       | ((W)driverInfo->interruptBuffer[3] << 8),
                       driverInfo->interruptBuffer[4]
                       | ((W)driverInfo->interruptBuffer[5] << 8),
                       &x,
                       &y);

#if 1
        /* ݥ󥿤ο̤ޤ */
        if ((x - px) * (x - px) + (y - py) * (y - py) < 25) {
          // ݥ󥿤̤Ȥ
          messageToKBPD.xpos = x = px;
          messageToKBPD.ypos = y = py;
        }
        else {
          // 礭ưȤ
          messageToKBPD.xpos = px = x;
          messageToKBPD.ypos = py = y;
        }
#else
        messageToKBPD.xpos = x;
        messageToKBPD.ypos = y;
#endif
        messageToKBPD.stat.main = (driverInfo->interruptBuffer[1]) & 0x01;
        messageToKBPD.stat.onebut = (driverInfo->interruptBuffer[1]) & 0x03;
        messageToKBPD.stat.sub  =
          (((driverInfo->interruptBuffer[1] & 0x06) != 0) ? 1 : 0);
           
        
        if ((errorCode = snd_msg(driverInfo->kbpdMailboxID,
                                 (VP)&messageToKBPD)) < ER_OK) {
          DEBUG_PRINT(("snd_msg() failed\n"));
          goto error;
        }

        // ξϥ֥졼˻Ѥ
        if (!prevButtonState && ((driverInfo->interruptBuffer[1]) & 0x01)) {
          pressedLocation.x = driverInfo->interruptBuffer[2]
            | ((W)driverInfo->interruptBuffer[3] << 8);
          pressedLocation.y = driverInfo->interruptBuffer[4]
            | ((W)driverInfo->interruptBuffer[5] << 8);
          DEBUG_PRINT(("[PDPressed x:%d y:%d]\n",
                       pressedLocation.x,
                       pressedLocation.y));
        }
      }
      prevButtonState = ((driverInfo->interruptBuffer[1]) & 0x07);

      // Υǡꥯ
      errorCode = usbIoPipe(driverInfo->interruptPipeID,
                            driverInfo->interruptBuffer,
                            driverInfo->reportSize,
                            NULL);
      if (errorCode < ER_OK)
        DEBUG_PRINT(("usbIoPipe() failed\n"));
    } else {
      DEBUG_PRINT(("unexpected error code (error=%#x, pid=%d)\n",
                   message.error, message.pid)); // XXX
    }
  }
  DEBUG_PRINT(("f430: InterruptHandlerTask(): finished\n"));
  exd_tsk();
  
 error:
  DEBUG_PRINT(("InterruptHandlerTask(): errorCode = %d\n", errorCode));
  exd_tsk();
}

static WERR StartDriver()
{
  DriverInfo *driverInfo = NULL;
  T_CTSK      ctsk;
  ID	        taskID = -1;
  ERR         errorCode;

  DEBUG_PRINT(("StartDriver(): started\n"));
  
  // ɥ饤Сν
  if ((driverInfo = (DriverInfo*)Kcalloc(1, sizeof(DriverInfo))) == NULL) {
    DEBUG_PRINT(("StartDriver(): not enough memory"));
    errorCode = ER_NOMEM;
    goto error;
  }
  driverInfo->acceptingPort          = -1;
  driverInfo->interfaceID            = -1;
  driverInfo->interruptPipeID        = -1;
  driverInfo->interruptPipeMailboxID = -1;
  driverInfo->interruptBuffer        = NULL;
  driverInfo->deviceRequest          = NULL;
  driverInfo->deviceDesc             = NULL;
  driverInfo->configDesc             = NULL;
  driverInfo->reportDesc             = NULL;
  driverInfo->usbDeviceID            = -1;

  // ư
  ctsk.exinf   = driverInfo;
  ctsk.task    = MainTask;
  ctsk.itskpri = taskPriority;
  ctsk.stksz   = 2048;
  ctsk.tskatr  = TA_HLNG|TA_RNG0;
  if ((taskID = errorCode = vcre_tsk(&ctsk)) < E_OK) {
    DEBUG_PRINT(("failed to create the main task\n"));
    errorCode = toERR(EC_INNER, errorCode);
    goto error;
  }
  if ((errorCode = sta_tsk(taskID, (INT)driverInfo)) < E_OK) {
    DEBUG_PRINT(("failed to start the main task"));
    errorCode = toERR(EC_INNER, errorCode);
  }
  
  return taskID;
  
 error:
  if (taskID >= 0)
    del_tsk(taskID);
  if (driverInfo)
    Kfree((VB*)driverInfo);
  DEBUG_PRINT(("StartUSDDriver() returned error code %d\n", errorCode));
  return errorCode;
}

static ERR GetParameters(TC *arg)
{
  while ( *arg != TNULL ) {
    if ( tc_isspace(*arg) ) {
      arg++;
      continue;
    }
    switch ( *arg++ ) {
    case 0x212a: // L'': ͥ 
      taskPriority = tc_strtol(arg, &arg, 0);
      break;

    default:
      return ER_PAR;
    }
  }
  return ER_OK;
}

ERR StartAcceptingDeviceRequests(DriverInfo *driverInfo)
{
  ERR    errorCode;
  RNO	   rendezvousNo;
  DevReq deviceRequest;
  INT    deviceRequestSize;
  DevRsp deviceResponse;
  
  while (True) {
    // ׵դ
    if ((errorCode = acp_por(&rendezvousNo,
                             (VP)&deviceRequest,
                             &deviceRequestSize,
                             driverInfo->acceptingPort,
                             D_NORM_PTN
                             | D_CALPTN(DC_ABORT)
                             | D_CALPTN(DC_SUSPEND)
                             | D_CALPTN(DC_RESUME)
                             | D_CALPTN(DC_USBEVENT))) < E_OK) {
      DEBUG_PRINT(("acp_por() returned error code %d\n", errorCode));
      continue;
    }
    
    // ѥåȤν
    // 顼ξθ˽Ƥ
    deviceResponse.devid   = deviceRequest.devid;
    deviceResponse.cmd     = deviceRequest.cmd;
    deviceResponse.datano  = deviceRequest.datano;
    deviceResponse.datacnt = 0;
    
    // ʾϥ顼
    if (deviceRequestSize != sizeof(DevReq)) {
      errorCode = toERR(EC_PAR, ED_CMD);
      DEBUG_PRINT(("f430: invalid devReq size (%d)\n", deviceRequestSize));
      goto error;
    }
    
    // ¹
    errorCode = ProcessDeviceRequest(driverInfo,
                                     &deviceResponse, &deviceRequest);
    
  error:
    deviceResponse.error.err = errorCode;
    
    // 
    if ((errorCode = rpl_rdv(rendezvousNo,
			     (VP)&deviceResponse, sizeof(DevRsp))) < E_OK)
      DEBUG_PRINT(("rpl_rdv() returned error code %d\n", errorCode));
  }
  
  return ER_SYS;  // 뤳ȤϤʤϤ
}

static ERR
ProcessDeviceRequest(DriverInfo *driverInfo,
                     DevRsp *deviceResponse,
                     DevReq *deviceRequest)
{
  switch (deviceRequest->cmd.cmd) {
  case DC_OPEN:
    return ProcessOpenDeviceRequest(driverInfo, deviceRequest->devid);

  case DC_CLOSE:
  case DC_CLOSEALL:
    return ProcessCloseDeviceRequest(driverInfo);

  case DC_READ:
    return ProcessReadRequest(driverInfo, deviceResponse,deviceRequest);

  case DC_WRITE:
    return ProcessWriteRequest(driverInfo, deviceResponse,deviceRequest);

  case DC_USBEVENT:
    return ProcessUSBEventRequest(driverInfo, deviceResponse, deviceRequest);
    
  case DC_SUSPEND:
  case DC_RESUME:
  case DC_ABORT:
    // ʤŸڤʤ
    return ER_OK;

  default:
    return toERR(EC_PAR, ED_CMD);
  }
}

static ERR ProcessOpenDeviceRequest(DriverInfo *driverInfo, ID deviceID)
{
  ERR errorCode;

  // ǥХϤǤ˥ץ󤵤Ƥ
  if (deviceID == driverInfo->deviceID && driverInfo->opened) {
    errorCode = ER_BUSY;
    goto error;
  }

  // ץ
  if (!driverInfo->opened)
    driverInfo->opened = True;
  
  return ER_OK;
  
 error:
  printf("ProcessOpenDeviceRequest() returned 0x%08x\n", errorCode);
  return errorCode;
}

static ERR ProcessCloseDeviceRequest(DriverInfo *driverInfo)
{
  driverInfo->opened = False;
  return ER_OK;
}

static ERR ProcessReadRequest(DriverInfo *driverInfo,
                              DevRsp *deviceResponse,
                              DevReq *deviceRequest)
{
  ERR errorCode;
 
  if (deviceRequest->datacnt < 0) {
    errorCode = toERR(EC_PAR, ED_DATACNT);
    goto error;
  }
  
  if ((errorCode = SetAndCheckTaskSpace(deviceRequest)) < ER_OK)
    goto error;

  errorCode = ER_NOSPT;
  switch (deviceRequest->datano) {
  case 0: // Ǹ˥ץ쥹줿κɸ
    if (deviceRequest->datacnt != 8) {
      errorCode = ER_PAR;
    } else {
      memcpy(deviceRequest->memptr, &pressedLocation, sizeof(pressedLocation));
      errorCode = ER_OK;
    }
    break;

  case 2: // åѥͥ뤬³Ƥ뤫ɤ
    if (deviceRequest->datacnt != 4) {
      errorCode = ER_PAR;
    } else {
      *(W *)(deviceRequest->memptr) = (driverInfo->usbDeviceID >= 0);
      errorCode = ER_OK;
    }
  }

  return errorCode;
  
 error:
  printf("ProcessReadRequest() returned 0x%08x\n", errorCode);
  return errorCode;
}

static ERR ProcessWriteRequest(DriverInfo *driverInfo,
                               DevRsp *deviceResponse,
                               DevReq *deviceRequest) 
{
  ERR errorCode;
 
  if (deviceRequest->datacnt < 0) {
    errorCode = toERR(EC_PAR, ED_DATACNT);
    goto error;
  }
  
  if ((errorCode = SetAndCheckTaskSpace(deviceRequest)) < ER_OK)
    goto error;

  printf("deviceRequest->datano = %d\n", deviceRequest->datano);

  errorCode = ER_NOSPT;
#if 0
  switch (deviceRequest->datano) {
  case 1: // ֥졼
    if (deviceRequest->datacnt != sizeof(CalibrationInfo)) {
      errorCode = ER_PAR; // TODO: ˤǤΤĴ٤
    } else {
      memcpy(&calibInfo,
             deviceRequest->memptr,
             sizeof(CalibrationInfo));
      calibInfo2.initialized = False;
      printf("f430: calibration info has been passed\n");
      errorCode = ER_OK;
    }
    printf("calibration info has been passed to the touchpanel driver\n");
  }
#endif
  return errorCode;
  
 error:
  printf("ProcessReadRequest() returned 0x%08x\n", errorCode);
  return errorCode;
}

ERR SetAndCheckTaskSpace(DevReq *deviceRequest)
{
	ERR	errorCode;

	if (deviceRequest->cmd.adcnv == 0 || deviceRequest->datacnt <= 0)
    return ER_OK;

	// ɥ쥹֤
	errorCode = SetTaskSpace(deviceRequest->taskid);
	if (errorCode != ER_OK) {
		DEBUG_PRINT(("SetTaskSpace() failed\n"));
		return errorCode;
	}

	// ɥ쥹֤Υå
	if (deviceRequest->cmd.cmd == DC_READ) {
		errorCode = CheckSpaceRW(deviceRequest->memptr, deviceRequest->datacnt);
	} else {
		errorCode = CheckSpaceR(deviceRequest->memptr, deviceRequest->datacnt);
	}
	if (errorCode != ER_OK) {
		DEBUG_PRINT(("CheckSpace*() failed\n"));
		return errorCode;
	}

	return ER_OK;

 error:
  printf("SetAndCheckTaskSpace() returned 0x%08x\n", errorCode);
  return errorCode;
}

static ERR CheckDataCount(DevReq *deviceRequest, W dataSize)
{
	W	requestedCount = deviceRequest->datacnt;

	if (requestedCount < dataSize && requestedCount != 0) {
		return toERR(EC_PAR, ED_DATACNT);
  } else {
    return requestedCount;
  }
}

static ERR ProcessUSBEventRequest(DriverInfo *driverInfo,
                                  DevRsp *deviceResponse,
                                  DevReq *deviceRequest)
{
  W errorCode = toERR(EC_PAR, ED_CMD);
  
  if (!(deviceRequest->devid & 0x80)
      && deviceRequest->datano == USB_MOUNT) {
    // ǥХ³
    driverInfo->usbDeviceID = deviceRequest->devid;
    //GetDeviceDescriptor(driverInfo);
    GetDescriptors(driverInfo);
    if (driverInfo->deviceDesc == 0) goto fin0;

    if (driverInfo->deviceDesc->idVendor  == TOUCHPANEL_VENDOR_ID &&
        (driverInfo->deviceDesc->idProduct == FAVO430_PRODUCT_ID ||
         driverInfo->deviceDesc->idProduct == FAVO440_PRODUCT_ID || 
         driverInfo->deviceDesc->idProduct == BIZTABLET_PRODUCT_ID)) {
      // ŪΥǥХ³줿
      if (driverInfo->deviceDesc->idProduct == FAVO430_PRODUCT_ID || 
        driverInfo->deviceDesc->idProduct == FAVO440_PRODUCT_ID) {
        driverInfo->devWidth = 0x27e0; driverInfo->devHeight = 0x1d00;
      }
      else {
        driverInfo->devWidth = 0x0cb0; driverInfo->devHeight = 0x0910;
      }
      DEBUG_PRINT(("f430: touchpanel connected\n"));
      //GetConfigurationDescriptor(driverInfo);
      OpenDevice(driverInfo);
      errorCode = USB_OWN;
    } else {
      driverInfo->usbDeviceID = -1;
    }
    // PrintDeviceDescriptor(driverInfo->deviceDesc);
    // PrintConfigurationDescriptor(driverInfo->configDesc);

  } else if (!(deviceRequest->devid & 0x80)
             && (deviceRequest->datano == USB_UNMOUNT)
             && deviceRequest->devid == driverInfo->usbDeviceID) {
    // ǥХ
    DEBUG_PRINT(("f430: touchpanel disconnected"));
    CloseDevice(driverInfo);
    
  } else {
    // ¾
    DEBUG_PRINT(("f430: unsupported usb event"));
  }
 fin0:
  return errorCode;
}

static ERR OpenDevice(DriverInfo *driverInfo)
{
  ERR    errorCode = ER_OK;
  T_CTSK ctsk;
  T_CMBF cmbf;

  DEBUG_PRINT(("OpenDevice(): started\n"));
  if ((errorCode = usbOpenDevice(driverInfo->usbDeviceID)) < E_OK) {
    printf("failed to open the device 0x%08x\n", errorCode);
    goto error;
  }
  if ((errorCode = usbConfigDevice(driverInfo->usbDeviceID,
                                   driverInfo->configDesc->bConfigurationValue)) < ER_OK) {
    printf("failed to set the configuration 0x%08x\n", errorCode);
    goto error;
  }

  if ((errorCode = usbOpenInterface(driverInfo->usbDeviceID, 0)) < ER_OK) {
    printf("failed to open the interface\n");
    goto error;
  }
  driverInfo->interfaceID = errorCode;

  // get a report descriptor
  if ((errorCode = GetReportDescriptor(driverInfo)) < ER_OK)
    goto error;

  // create a mailbox for interrupt transfer
  if (driverInfo->interruptPipeMailboxID <= 0) {
    cmbf.exinf  = NULL;
    cmbf.mbfatr = TA_NULL;
    cmbf.maxmsz = sizeof(usbMsg);
    cmbf.bufsz  = cmbf.maxmsz * 64;
    if ((errorCode = vcre_mbf(&cmbf)) < ER_OK) {
      DEBUG_PRINT(("failed to create a mailbox for interrupt transfer\n"));
      goto error;
    }
    driverInfo->interruptPipeMailboxID = errorCode;
  }

  if ((errorCode = device_init(driverInfo->usbDeviceID, 1)) < 0) {
    DEBUG_PRINT(("failed to initiailze device. (%d)\n", errorCode));
    goto error;
  }

  if ((errorCode = usbOpenPipe(driverInfo->interfaceID,
                               0x81,
                               USB_NOWAIT | USB_SHORTOK,
                               driverInfo->interruptPipeMailboxID)) < E_OK) {
    printf("failed to open the endpoint\n");
    goto error;
  }
  driverInfo->interruptPipeID = errorCode;
  DEBUG_PRINT(("endpoint opened successfully (%d)\n", errorCode));

  // ѤΥХåեѰ
  driverInfo->reportSize = 8;
  if ((driverInfo->interruptBuffer
       = Kcalloc(sizeof(UB),
                 driverInfo->reportSize)) == NULL) {
    printf("cannot obtain buffer for interrupt endpoint\n");
    errorCode = ER_NOMEM;
    goto error;
  }

  // 餫ǡĹ0ΥꥯȤФƤʤ
  // USB_STALLȯ롣ǤϤޤޤä
  driverInfo->reportSize = 5;
  driverInfo->interruptBuffer[0] = 0x01;
  driverInfo->interruptBuffer[1] = 0;
  driverInfo->interruptBuffer[2] = 0;
  driverInfo->interruptBuffer[3] = 0;
  driverInfo->interruptBuffer[4] = 0;
  errorCode = usbIoPipe(driverInfo->interruptPipeID,
                        driverInfo->interruptBuffer,
                        driverInfo->reportSize, NULL);
  //  errorCode = usbIoPipe(driverInfo->interruptPipeID, NULL, 0, NULL);
  if (errorCode != USB_OK) {
    printf("failed to issue an input request\n");
    goto error;
  }
  driverInfo->reportSize = 8;

  // create interrupt handler task
  DEBUG_PRINT(("creating interrupt handler task...\n"));
  ctsk.exinf   = driverInfo;
  ctsk.task    = InterruptHandlerTask;
  ctsk.itskpri = taskPriority;
  ctsk.stksz   = 2048;
  ctsk.tskatr  = TA_HLNG|TA_RNG0;
  if ((errorCode = vcre_tsk(&ctsk)) < E_OK) {
    DEBUG_PRINT(("failed to create interrupt handler task\n"));
    errorCode = toERR(EC_INNER, errorCode);
    goto error;
  }
  driverInfo->interruptHandlerTaskID = errorCode;
  if ((errorCode = sta_tsk(driverInfo->interruptHandlerTaskID,
                           (INT)driverInfo)) < E_OK) {
    DEBUG_PRINT(("failed to start interrupt handler task"));
    errorCode = toERR(EC_INNER, errorCode);
  }

  return ER_OK;

 error:
  DEBUG_PRINT(("OpenDevice(): errorCode = 0x%08x\n", errorCode));
  return errorCode;
}

#define KFREE_IF_NOT_NULL(p) \
  if (p) {                   \
    Kfree(p);                \
    (p) = NULL;              \
  }

static void CloseDevice(DriverInfo *driverInfo)
{
  if (driverInfo->usbDeviceID < 0)
    return;
  usbCloseDevice(driverInfo->usbDeviceID);
  driverInfo->usbDeviceID            = -1;
  driverInfo->interfaceID            = -1;
  driverInfo->interruptPipeID        = -1;
  del_tsk(driverInfo->interruptHandlerTaskID);
  driverInfo->interruptHandlerTaskID = -1;
  del_mbf(driverInfo->interruptPipeMailboxID);
  driverInfo->interruptPipeMailboxID = -1;
  KFREE_IF_NOT_NULL(driverInfo->interruptBuffer);
  KFREE_IF_NOT_NULL(driverInfo->deviceRequest);
  KFREE_IF_NOT_NULL(driverInfo->deviceDesc);
  KFREE_IF_NOT_NULL(driverInfo->configDesc);
  KFREE_IF_NOT_NULL(driverInfo->reportDesc);
}

static ERR GetDescriptors(DriverInfo *driverInfo)
{
  int i;

  usbDeviceDescriptor *deviceDescriptorBody;
  usbConfigurationDescriptor *configDescriptorBody;
  B buf[256];
  W actualLength;
  W errorCode;

  if ((errorCode = usbDescriptorDevice(driverInfo->usbDeviceID,
                                       NULL,
                                       0,
                                       &actualLength)) < ER_OK) {
    DEBUG_PRINT((DEVICE_NAME ": first usbDescriptorDevice() failed\n"));
    goto error;
  }
  if (actualLength > sizeof(buf)) {
    DEBUG_PRINT((DEVICE_NAME ": buffer size too small...\n"));
    goto error;
  }
  if ((errorCode = usbDescriptorDevice(driverInfo->usbDeviceID,
                                       buf,
                                       actualLength,
                                       NULL)) < ER_OK) {
    DEBUG_PRINT((DEVICE_NAME ": second usbDescriptorDevice() failed\n"));
    goto error;
  }
  
  for (i = 0; i < actualLength; ) {
    usbDeviceDescriptor* p = (usbDeviceDescriptor*)&(buf[i]);
    switch (p->bDescriptorType) {
    case USB_DEVICE:
      DEBUG_PRINT(("USB_DEVICE\n"));
      if (driverInfo->deviceDesc) {
        Kfree((VP)driverInfo->deviceDesc);
        driverInfo->deviceDesc = NULL;
      }
      if ((deviceDescriptorBody = Kmalloc(p->bLength)) == NULL) {
        DEBUG_PRINT((DEVICE_NAME ": Kmalloc() failed\n"));
        errorCode = ER_NOMEM;
        goto error;
      }
      memcpy(deviceDescriptorBody, &(buf[i]), p->bLength);
      driverInfo->deviceDesc = deviceDescriptorBody;
      break;
    case USB_CONFIGURATION:
      DEBUG_PRINT(("USB_CONFIGURATION\n"));
      // configurations = 1 Τ褦ʤΤǤʤ??
      if (driverInfo->configDesc) {
        Kfree((VP)driverInfo->configDesc);
        driverInfo->configDesc = NULL;
      }
      if ((configDescriptorBody = Kmalloc(p->bLength)) == NULL) {
        DEBUG_PRINT((DEVICE_NAME ": Kmalloc() failed\n"));
        errorCode = ER_NOMEM;
        goto error;
      }
      memcpy(configDescriptorBody, &(buf[i]), p->bLength);
      driverInfo->configDesc = configDescriptorBody;
      break;
    default:
      DEBUG_PRINT(("USB_*\n"));
      // USB_(STRING, INTERFACE, ENDPOINT)
      break;
    }
    i += p->bLength;
  }

  return ER_OK;

 error:
  DEBUG_PRINT((DEVICE_NAME ": GetDescriptors() failed: errorCode = 0x%08x\n",
               errorCode));
  return errorCode;
}

#if 0
static ERR GetDeviceDescriptor(DriverInfo *driverInfo) 
{
  static struct {
    UB bmRequestType;
    UB bRequest;
    UH wValue;
    UH wIndex;
    UH wLength;
  } getDescriptorRequest = {
    0x80,   // bmRequestType
    0x06,   // bRequest: GET_DESCRIPTOR
    0x0100, // wValue: DEVICE
    0,      // wIndex
    18      // wLength
  };
  usbDeviceDescriptor *descriptorBody;
  W actualDescriptorLength;
  W errorCode;
  
  if (driverInfo->deviceDesc) {
    Kfree((VP)driverInfo->deviceDesc);
    driverInfo->deviceDesc = NULL;
  }
  if ((descriptorBody = Kcalloc(sizeof(UB),
                                getDescriptorRequest.wLength)) == NULL) {
    DEBUG_PRINT(("Kcalloc() failed\n"));
    errorCode = ER_NOMEM;
    goto error;
  }
  
  if ((errorCode = usbRequestDevice(driverInfo->usbDeviceID,
                                    (VP)&getDescriptorRequest,
                                    (VP)descriptorBody,
                                    getDescriptorRequest.wLength,
                                    &actualDescriptorLength)) < ER_OK) {
    DEBUG_PRINT(("usbRequestDevice() failed\n"));
    goto error;
    
  }
  
  driverInfo->deviceDesc = descriptorBody;
  return ER_OK;

 error:
  DEBUG_PRINT(("GetDeviceDescriptor() failed: errorCode = 0x%08x\n",
               errorCode));
  return errorCode;
}

static ERR GetConfigurationDescriptor(DriverInfo *driverInfo) 
{
  static struct {
    UB bmRequestType;
    UB bRequest;
    UH wValue;
    UH wIndex;
    UH wLength;
  } getDescriptorRequest = {
    0x80,   // bmRequestType
    0x06,   // bRequest: GET_DESCRIPTOR
    0x0200, // wValue: CONFIGURATION
    0,      // wIndex
    9       // wLength
  };
  usbConfigurationDescriptor *descriptorBody;
  W actualDescriptorLength;
  W errorCode;
  
  if (driverInfo->configDesc) {
    Kfree((VP)driverInfo->configDesc);
    driverInfo->configDesc = NULL;
  }
  if ((descriptorBody = Kcalloc(sizeof(UB),
                                getDescriptorRequest.wLength)) == NULL) {
    DEBUG_PRINT(("Kcalloc() failed\n"));
    errorCode = ER_NOMEM;
    goto error;
  }
  if ((errorCode = usbRequestDevice(driverInfo->usbDeviceID,
                                    (VP)&getDescriptorRequest,
                                    (VP)descriptorBody,
                                    getDescriptorRequest.wLength,
                                    &actualDescriptorLength)) < ER_OK) {
    DEBUG_PRINT(("usbRequestDevice() failed\n"));
    goto error;
    
  }
  
  if (descriptorBody->wTotalLength > getDescriptorRequest.wLength) {
    getDescriptorRequest.wLength = descriptorBody->wTotalLength;
    Kfree(descriptorBody);
    if ((descriptorBody = Kcalloc(sizeof(UB),
                                  getDescriptorRequest.wLength)) == NULL) {
      DEBUG_PRINT(("Kcalloc() failed\n"));
      errorCode = ER_NOMEM;
      goto error;
    }
    if ((errorCode = usbRequestDevice(driverInfo->usbDeviceID,
                                      (VP)&getDescriptorRequest,
                                      (VP)descriptorBody,
                                      getDescriptorRequest.wLength,
                                      &actualDescriptorLength)) < ER_OK) {
      DEBUG_PRINT(("usbRequestDevice() failed\n"));
      goto error;
    }
  }

  driverInfo->configDesc = descriptorBody;
  return ER_OK;

 error:
  DEBUG_PRINT(("GetConfigurationDescriptor() failed: errorCode = 0x%08x\n",
               errorCode));
  return errorCode;
}
#endif

/* ǥХν */
static	ERR	device_init(W did, W bnumif /*, W bepadr*/)
{
 	ERR	err;
 	usbDeviceRequest	r;
 	UB	buf[2];

 	/* SET_PROTOCOL(Report Protocol)ȯԤ */
 	r.bmRequestType = 0x21;		/* bmR_CLASS | bmR_INTERFACE */
 	r.bRequest	= 0x0b;		/* SET_PROTOCOL */
 	r.wValue	= 0x0001;	/* Report Protocol */
 	r.wIndex	= bnumif;

 	err = usbRequestDevice(did, &r, NULL, 0, NULL);
 	if (err < ER_OK) {
 		DEBUG_PRINT(("device_init: usbRequestDevice %d\n", err));
 		goto fin0;
 	}
 
 	/* WACOMΥޥ */
 	buf[0] = 0x02;
 	buf[1] = 0x02;
 	r.bmRequestType = 0x21;		/* bmR_CLASS | bmR_INTERFACE */
 	r.bRequest	= 0x09;		/* SET_REPORT */
 	r.wValue	= 0x0302;
 	r.wIndex	= bnumif;
 
 	err = usbRequestDevice(did, &r, buf, sizeof(buf), NULL);
 	if (err < ER_OK) {
 		DEBUG_PRINT(("device_init: usbRequestDevice %d\n", err));
 	}		
 
 fin0:
 	return err;
}

static ERR GetReportDescriptor(DriverInfo *driverInfo) 
{
  static struct {
    UB bmRequestType;
    UB bRequest;
    UH wValue;
    UH wIndex;
    UH wLength;
  } getDescriptorRequest = {
    0x81,   // bmRequestType
    0x06,   // bRequest: GET_DESCRIPTOR
    0x2200, // wValue: REPORT
    0,      // wIndex
    0x00a2,   // wLength
  };
  UB *descriptorBody;
  W   actualDescriptorLength;
  W   errorCode;
  
  if (driverInfo->reportDesc) {
    Kfree((VP)driverInfo->reportDesc);
    driverInfo->reportDesc = NULL;
  }
  if ((descriptorBody = Kcalloc(sizeof(UB),
                                getDescriptorRequest.wLength)) == NULL) {
    DEBUG_PRINT(("Kcalloc() failed\n"));
    errorCode = ER_NOMEM;
    goto error;
  }

  if ((errorCode = usbRequestDevice(driverInfo->usbDeviceID,
                                    (VP)&getDescriptorRequest,
                                    descriptorBody,
                                    getDescriptorRequest.wLength,
                                    &actualDescriptorLength)) < ER_OK) {
    DEBUG_PRINT(("usbRequestDevice() failed\n"));
    goto error;

  }
  
  driverInfo->reportDesc = descriptorBody;
  driverInfo->reportDescSize = actualDescriptorLength;
  return ER_OK;

 error:
  DEBUG_PRINT(("GetReportDescriptor() failed: errorCode = 0x%08x\n",
               errorCode));
  return errorCode;
}

#define PRINT_NAME_OF_MEMBER_OF_DESCRIPTOR(member)	\
  printf("%20s = ", #member)
#define PRINT_INT_MEMBER_OF_DESCRIPTOR(structure, member)	\
  printf("%20s = %d\n", #member, structure->member)
#define PRINT_BCD_MEMBER_OF_DESCRIPTOR(structure, member)	\
  printf("%20s = \"%04x\"\n", #member, structure->member)
#define PRINT_INT_MEMBER_OF_DESCRIPTOR2(member)	\
  printf("%20s = %d\n", #member, member)
#define PRINT_BCD_MEMBER_OF_DESCRIPTOR2(member)	\
  printf("%20s = \"%04x\"\n", #member, member)

static void PrintDeviceDescriptor(usbDeviceDescriptor *deviceDesc)
{
  printf("[device desciptor]");
  PRINT_INT_MEMBER_OF_DESCRIPTOR(deviceDesc, bLength);
  PRINT_INT_MEMBER_OF_DESCRIPTOR(deviceDesc, bDescriptorType);
  PRINT_BCD_MEMBER_OF_DESCRIPTOR(deviceDesc, bcdUSB);
  PRINT_INT_MEMBER_OF_DESCRIPTOR(deviceDesc, bDeviceClass);
  PRINT_INT_MEMBER_OF_DESCRIPTOR(deviceDesc, bDeviceSubClass);
  PRINT_INT_MEMBER_OF_DESCRIPTOR(deviceDesc, bDeviceProtocol);
  PRINT_INT_MEMBER_OF_DESCRIPTOR(deviceDesc, bMaxPacketSize0);
  PRINT_INT_MEMBER_OF_DESCRIPTOR(deviceDesc, idVendor);
  PRINT_INT_MEMBER_OF_DESCRIPTOR(deviceDesc, idProduct);
  PRINT_BCD_MEMBER_OF_DESCRIPTOR(deviceDesc, bcdDevice);
  // PRINT_STRING_MEMBER_OF_DESCRIPTOR(deviceDesc, iManufacturer);
  // PRINT_STRING_MEMBER_OF_DESCRIPTOR(deviceDesc, iProduct);
  // PRINT_STRING_MEMBER_OF_DESCRIPTOR(deviceDesc, iSerialNumber);
  PRINT_INT_MEMBER_OF_DESCRIPTOR(deviceDesc, bNumConfigurations);
}

static void PrintConfigurationDescriptor(usbConfigurationDescriptor *configDesc)
{
  printf("[configuration descriptor]\n");
  PRINT_INT_MEMBER_OF_DESCRIPTOR(configDesc, bLength);
  PRINT_INT_MEMBER_OF_DESCRIPTOR(configDesc, bDescriptorType);
  PRINT_INT_MEMBER_OF_DESCRIPTOR(configDesc, wTotalLength);
  PRINT_INT_MEMBER_OF_DESCRIPTOR(configDesc, bNumInterfaces);
  PRINT_INT_MEMBER_OF_DESCRIPTOR(configDesc, bConfigurationValue);
  // PRINT_STRING_MEMBER_OF_DESCRIPTOR(configDesc, iConfiguration);
  PRINT_INT_MEMBER_OF_DESCRIPTOR(configDesc, bmAttributes);
  PRINT_INT_MEMBER_OF_DESCRIPTOR(configDesc, MaxPower);
}

static void PrintInterfaceDescriptor(usbInterfaceDescriptor *interfaceDesc)
{
  printf("[interface descriptor]");
  PRINT_INT_MEMBER_OF_DESCRIPTOR(interfaceDesc, bLength);
  PRINT_INT_MEMBER_OF_DESCRIPTOR(interfaceDesc, bDescriptorType);
  PRINT_INT_MEMBER_OF_DESCRIPTOR(interfaceDesc, bInterfaceNumber);
  PRINT_INT_MEMBER_OF_DESCRIPTOR(interfaceDesc, bAlternateSetting);
  PRINT_INT_MEMBER_OF_DESCRIPTOR(interfaceDesc, bNumEndpoints);
  PRINT_INT_MEMBER_OF_DESCRIPTOR(interfaceDesc, bInterfaceClass);
  PRINT_INT_MEMBER_OF_DESCRIPTOR(interfaceDesc, bInterfaceSubClass);
  PRINT_INT_MEMBER_OF_DESCRIPTOR(interfaceDesc, bInterfaceProtocol);
  // PRINT_STRING_MEMBER_OF_DESCRIPTOR(interfaceDesc, iInterface);
}

static ERR RegisterDriverToKBPD(DriverInfo *driverInfo)
{
  TC kbpdName[5];
  W  kbpdDeviceDesc;
  W  errorCode;
  W  actualSize;
  ID kbpdMailboxID;

  eucstotcs(kbpdName, "kbpd");
  if ((errorCode = b_opn_dev(kbpdName, D_READ, NULL)) < ER_OK) {
    DEBUG_PRINT(("f430: failed to open device\n"));
    goto error;
  }
  kbpdDeviceDesc = errorCode;
  
  errorCode = b_rea_dev(kbpdDeviceDesc,
                        -100, // DN_KPINPUT
                        (VP)&kbpdMailboxID,
                        sizeof(ID),
                        &actualSize,
                        NULL);
  if (errorCode < ER_OK) {
    DEBUG_PRINT(("f430: failed to read from device\n"));
    goto error;
  }
  DEBUG_PRINT(("kbpdMailboxID = %d\n", kbpdMailboxID));
  driverInfo->kbpdMailboxID = kbpdMailboxID;
  b_cls_dev(kbpdDeviceDesc, 0, NULL);
  
  return ER_OK;

 error:
  DEBUG_PRINT(("RegisterDriverToKBPD(): errorCode = 0x%08x\n", errorCode));
  return errorCode;
}





///////////////////////////////////////////////////////////////////////////////
// Emacsѿ
///////////////////////////////////////////////////////////////////////////////

// Local Variables:
// compile-command: "make -C ../pcat -k"
// End:
